#include <assert.h>

bool containsInt(int* array, int size, int what);
int stringLength(char* str);
void setAllTo(int* array, int size, int toWhat);
int getProduct(int* array, int size);
int largestElement(int* array, int size);
int largestElementHelper(int* array, int size, int curLargest);
bool allEqualThis(int* array, int size, int what);

bool containsInt(int* array, int size, int what) {
  if (size <= 0) return false;
  else if (*array == what) return true;
  else return containsInt(array + 1, size - 1, what);
}

int stringLength(char* str) {
  if (*str == '\0') return 0;
  else return 1 + stringLength(str + 1);
}

void setAllTo(int* array, int size, int toWhat) {
  if (size > 0) {
    *array = toWhat;
    setAllTo(array + 1, size - 1, toWhat);
  }
}

int getProduct(int* array, int size) {
  if (size <= 0) return 1;
  else return *array * getProduct(array + 1, size - 1);
}

int largestElement(int* array, int size) {
  if (size <= 0) return -1;
  else return largestElementHelper(array + 1, size - 1, *array);
}

int largestElementHelper(int* array, int size, int soFar) {
  if (size <= 0) return soFar;
  else return largestElementHelper(array + 1, size - 1,
                                   (*array > soFar) ? *array : soFar);
}

bool allEqualThis(int* array, int size, int what) {
  if (size <= 0) return true;
  else return *array == what && allEqualThis(array + 1, size - 1, what);
}

int main() {
  int arr[] = {5, 1, 2, 3, 4};
  int size = 5;

  assert(containsInt(arr, size, 2));
  assert(stringLength((char*)"foobar") == 6);
  assert(getProduct(arr, size) == 120);
  assert(largestElement(arr, size) == 5);

  setAllTo(arr, size, 1);
  assert(allEqualThis(arr, size, 1));

  return 0;
}
