#include <cstddef>
#include <assert.h>

#include "Node.h"

bool containsInt(Node* head, int what);
void setAllTo(Node* head, int toWhat);
bool allEqualThis(Node* head, int what);
int getProduct(Node* head);
int largestElement(Node* head);
int largestElementHelper(Node* head, int largest);

bool containsInt(Node* head, int what) {
  if (head == NULL) return false;
  else return head->getItem() == what || containsInt(head->getNext(), what);
}

void setAllTo(Node* head, int toWhat) {
  if (head != NULL) {
    head->setItem(toWhat);
    setAllTo(head->getNext(), toWhat);
  }
}

bool allEqualThis(Node* head, int what) {
  return (head == NULL || 
          (head->getItem() == what &&
           allEqualThis(head->getNext(), what)));
}

int getProduct(Node* head) {
  return (head == NULL) ? 1 : head->getItem() * getProduct(head->getNext());
}

int largestElement(Node* head) {
  return (head == NULL) ? -1 : largestElementHelper(head->getNext(),
                                                    head->getItem());
}

int largestElementHelper(Node* head, int largest) {
  if (head == NULL) return largest;
  else {
    int here = head->getItem();
    return largestElementHelper(head->getNext(),
                                (here > largest) ? here : largest);
  }
}

int main() {
  Node n5(4, NULL);
  Node n4(3, &n5);
  Node n3(2, &n4);
  Node n2(1, &n3);
  Node n1(5, &n2);
  Node* head = &n1;

  assert(containsInt(head, 2));
  assert(getProduct(head) == 120);
  assert(largestElement(head) == 5);

  setAllTo(head, 1);
  assert(allEqualThis(head, 1));

  return 0;
}
